#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "apu2context4xi.py">
#<abstract4xi abstract = "APU context management"/>
#<refer4xi reference = "context4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#<verify4xi verification = "10" target = "context4xi5test.py">
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'APU2Context4Xi',
            'create2context4apu',
            'get2context4apu',
            'release2context4apu',
            'retain2context4apu',
            'set2context4apu',
            'trace2context4apu'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi

from platformids4xi import get2platformids4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global apu2context4xi
global apu2trace4xi 
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2context4apu" usage = "
#
# 
#  task4create2apu = {}                                                                                            
#  task4create2apu= {}      
#  task4create2apu['FUNCTION2CALLBACK'] = trace2context4apu                                                           # CALLBACK FUNCTION CALLED BY DRAGONIZED OPENCL
#
#  args2callback = {}                                                                                                           
#  args2callback['CLASS']   = "create2context4apu"                                                                             # MODULE OF DRAGONIZED OPENCL MODULE
#  args2callback['METHOD']  = "create2context4apu"                                                                             # FUNCTION OF DRAGONIZED OPENCL MODULE
#  args2callback['MESSAGE'] = "{(Step 2Z1/33) failed" + "; create2context4apu-failed " + "; time: " + time4xi() + "}"          # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    
#  
#  task4create2apu['ARGS2CALLBACK'] = args2callback                                                                   # MAX ONE ARG - THEREFORE GIVE SEVERAL ARGS IN ONE DICTIONARY 
#  
#  response4create2context = {}
#  print('(Step 1A/33) OF CONTEXT4XI5TEST - TRYING TO CREATE CONTEXT FOR APU ', time4xi())  
#  try:                               
#      response4create2context = create2context4apu (task4create2context)                                                      # EXAMINE RESPONSE!                                                      
#      print('(Step 1B/33) OF CONTEXT4XI5TEST - RESPONSE4CREATE2CONTEXT : ', response4create2context)                          # trace2context4apu CALLED BY DRAGONIZED OPENCL IN EXCEPTIONS - CHECK DRAGONIZED TRACE!                       
#  except: 
#      print('(Step Z1/33) OF CONTEXT4XI5TEST *** FAILED TO CREARE CONTEXT FOR APU ', time4xi())  
#
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def trace2context4apu(task4trace2apu=None):

    '''
    creates apu2context4xi
    '''
    
    global apu2trace4xi 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2context4apu" 
    method2print = "trace2context4apu"

    message2print = "{(Step 1A/33) started" + "; trace2context4apu-started: " + str(trace2context4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function trace2context4apu at 0x00000000031898C8>  
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2apu-to-trace2context4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
    #    'CLASS': 'get2context4apu', 
    #   'METHOD': 'get2context4apu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

    code2ack  = ' '
    code2nack = ' '    
    
    apu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2apu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY DRAGONIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2apu = {}                                                                                            
            
        task4trace2apu= {} 
  
        message2print = "{(Step 2A/33) warned" + "; task4trace2apu-warned-by-trace2context4apu to: " + str(task4trace2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
        code2nack = code2nack + '2A-'            

    else:
        # -----------------------------------------------------------------------------------------
        # PARAMETER GIVEN BY DRAGONIZED CALLBACK !
        # -----------------------------------------------------------------------------------------          
        message2print = "{(Step 3A/33) try" + "; task4trace2apu-try-by-trace2context4apu: " + str(task4trace2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
        #    'CLASS': 'get2context4apu', 
        #   'METHOD': 'get2context4apu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

        try:
            class2print   = task4trace2apu['CLASS']                                                                # DRAGONIZE APU TRACE!
            method2print  = task4trace2apu['METHOD']
            message2print = task4trace2apu['MESSAGE']
            print4xi(class2print, method2print, message2print)                                                     # DRAGONIZED TRACE FOR OPENCL CALLBACK!
            # =================================
            # { get2context4apu : get2context4apu ; (Step 6Z1/33) failed; get2context4apu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}
            # =================================
            
            class2print = "trace2context4apu"                                                                      # SET TRACE BACK TO THIS FUNCTION!
            method2print = "trace2context4apu"                
            message2print = "{(Step 3B/33) performed" + "; apu-trace-performed-by-trace2context4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # apu-trace-performed-by-trace2context4apu: 
            # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'get2context4apu', 
            #   'METHOD': 'get2context4apu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

            code2ack = code2ack + '3B-' 
        except:
            message2print = "{(Step 3Z1/33) failed" + "; apu-trace-failed-by-trace2context4apu: " + str(task4trace2apu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            code2nack = code2nack + '3Z1-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; trace2context4apu-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    # trace2context4apu-returning: 22:50:59 05/11/11 Pacific Daylight Time
    
    return
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2context4apu" usage = "
#     
#     context4xi = {}        
#     try:
#         context4xi['APU'] = create2context4apu()                                                                  # APU context      
#         message2print = "{(Step 2B/33) initialized" + "; apu-context4xi-initialized-by-create2context4xi to: " + str(context4xi)  + "; time: " + time4xi() + "}" 
#         print4xi(class2print, method2print, message2print)     
#         ....                                                                                                      # context of devices
#     except:
#        message2print = "{(Step 3Z1/33) yielded" + "; context4xi-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
#        print4xi(class2print, method2print, message2print)                                                              
#
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def create2context4apu(task4create2apu=None):

    '''
    creates apu2context4xi
    '''
    
    global apu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2context4apu" 
    method2print = "create2context4apu"

    message2print = "{(Step 1A/70) started" + "; create2context4apu-started: " + str(create2context4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2context4apu at 0x000000000339E948> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2apu-to-create2context4apu: " + str(task4create2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    apu2context4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2apu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - CREATE TASK CONTEXT
            # -----------------------------------------------------------------------------------------    
            task4create2apu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2apu-initialized-by-create2context4apu to: " + str(task4create2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            
            function2callback4apu = trace2context4apu                                                                      # CALLBACK FUNCTION FOR APU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4apu-initialized-by-create2context4apu to: " + str(function2callback4apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2context4apu at 0x000000000339E8C8>
            code2ack  = code2ack + '2A-'
           
            args2callback = {}                                                                                             # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2context4apu"                                                                # MODULE OF DRAGONIZED OPENCL MODULE
            args2callback['METHOD']  = "create2context4apu"                                                                # FUNCTION OF DRAGONIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2context4apu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DRAGONIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-initialized-by-create2context4apu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 20:18:34 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4apu', 
            #   'METHOD': 'create2context4apu'}; time: 20:18:34 05/11/11 Pacific Daylight Time}

              
            task4create2apu['DATA2CALLBACK'] = args2callback                                                      # USER DATA PASSED TO DRAGONIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2apu['FUNCTION2CALLBACK'] = function2callback4apu                                          # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) set" + "; task4create2apu-initialized-by-create2context4apu to: " + str(task4create2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {  'APU': {'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000031898C8>, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 20:43:04 05/11/11 Pacific Daylight Time}', 
            #  'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}}}; time: 20:43:04 05/11/11 Pacific Daylight Time}

            
            platform2xi = {}
            message2print = "{(Step 1G/70) initialized" + "; platform2xi-initialized-by-create2context4apu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # {}
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 1H/70) got" + "; platform2xi-got-by-create2context4apu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'available2platform': 1, 'max2entries': 1}
                code2ack  = code2ack + '2D-'
            except:
                message2print = "{(Step 1Z1/70) failed" + "; platform2xi-failed-by-create2context4apu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                         #
                 
            task4create2apu['PLATFORM'] = platform2xi                                                             # PLATFORM OF SYSTEM   
            task4create2apu['PROPERTIES'] = None                                                                  # CONTEXT PROPERTIES
            task4create2apu['INFO2PRIVATE'] = None                                                                # USED TO DEDUCE POINTER TO PRIVATE BINARY ERROR RETURNED BY OPENCL 
            task4create2apu['SIZE2PRIVATE'] = 0                                                                   # USED TO DEDUCE POINTER TO SIZE OF PRIVATE BINARY ERROR RETURNED BY OPENCL 
            
            task4create2apu ['COUNT2REFERENCE'] = 0                                                               # USED TO RETAIN(ATTACH) AND RELEASE CONTEXT 
              
            message2print = "{(Step 1I/70) created" + "; task4create2apu-initialized-by-create2context4apu to: " + str(task4create2apu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {  'APU': {'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 20:43:04 05/11/11 Pacific Daylight Time}', 
            #            'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000031898C8>, 
            #            'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
            #            'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 20:43:04 05/11/11 Pacific Daylight Time}

                        
            code2ack  = code2ack + '2E-'
            
                         
        else:
            pass                                                                                                           # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2apu-yielded-by-create2context4apu: " + str(task4create2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z2-' 

    apu2context4xi = {}                                                                                                    # INITIALIZE APU CONTEXT                                                                                      

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2apu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2context4apu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'PLATFORM' in keys2task:
        message2print = "{(Step 2A/70) try" + "; platform-try-by-create2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # {}
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 2/70) - PLATFORM
            # -----------------------------------------------------------------------------------------               
            apu2context4xi['PLATFORM'] = task4create2apu['PLATFORM']
            
            message2print = "{(Step 2B/70) initialized" + "; platform-initialized-by-create2context4apu to: " + str(apu2context4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 20:55:51 05/11/11 Pacific Daylight Time}
            code2ack  = code2ack + '2B-'
        except: 
            message2print = "{(Step 2Z1/70) yielded" + "; platform-apu2context4xi-yielded-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z1-' 

    if 'PROPERTIES' in keys2task:            
        message2print = "{(Step 3A/70) try" + "; properties-try-by-create2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/70) - PROPERTIES
            # -----------------------------------------------------------------------------------------               
            apu2context4xi['PROPERTIES'] = task4create2apu['PROPERTIES']
            
            message2print = "{(Step 3B/70) initialized" + "; properties-initialized-by-create2context4apu to: " + str(apu2context4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # None
            code2ack  = code2ack + '3B-'
        except: 
            message2print = "{(Step 3Z1/70) yielded" + "; properties-apu2context4xi-yielded-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '3Z1-' 

    if 'DATA2CALLBACK' in keys2task:        
        message2print = "{(Step 4A/70) try" + "; data2callback-try-by-create2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 4/70) - DATA2CALLBACK 
            # -----------------------------------------------------------------------------------------               
            apu2context4xi['DATA2CALLBACK'] = task4create2apu['DATA2CALLBACK']
            
            message2print = "{(Step 4B/70) initialized" + "; data2callback-initialized-by-create2context4apu to: " + str(apu2context4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 20:55:51 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4apu', 
            #   'METHOD': 'create2context4apu'}; time: 20:55:51 05/11/11 Pacific Daylight Time}
    
            code2ack  = code2ack + '4B-'
        except: 
            message2print = "{(Step 4Z1/70) yielded" + "; data2callback-apu2context4xi-yielded-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z1-'

    if 'INFO2PRIVATE' in keys2task:         
        message2print = "{(Step 5A/70) try" + "; info2private-try-by-create2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 5/70) - INFO2PRIVATE
            # -----------------------------------------------------------------------------------------               
            apu2context4xi['INFO2PRIVATE'] = task4create2apu['INFO2PRIVATE']
            
            message2print = "{(Step 5B/70) initialized" + "; info2private-initialized-by-create2context4apu to: " + str(apu2context4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # None
            code2ack  = code2ack + '5B-'
        except: 
            message2print = "{(Step 5Z1/70) yielded" + "; info2private-apu2context4xi-yielded-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '5Z1-'         

    if 'SIZE2PRIVATE' in keys2task:    
        message2print = "{(Step 6A/70) try" + "; size2private-try-by-create2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 6/70) - SIZE2PRIVATE
            # -----------------------------------------------------------------------------------------               
            apu2context4xi['SIZE2PRIVATE'] = task4create2apu['SIZE2PRIVATE']
            
            message2print = "{(Step 6B/70) initialized" + "; size2private-initialized-by-create2context4apu to: " + str(apu2context4xi['SIZE2PRIVATE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            code2ack  = code2ack + '6B-'
        except: 
            message2print = "{(Step 6Z1/70) yielded" + "; size2private-apu2context4xi-yielded-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '6Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:        
        message2print = "{(Step 7A/70) try" + "; function2callback-try-by-create2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 7/70) - FUNCTION2CALLBACK
            # -----------------------------------------------------------------------------------------               
            apu2context4xi['FUNCTION2CALLBACK'] = task4create2apu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 7B/70) initialized" + "; function2callback-initialized-by-create2context4apu to: " + str(apu2context4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2context4apu at 0x00000000032098C8>
            code2ack  = code2ack + '7B-'
        except: 
            message2print = "{(Step 7Z1/70) yielded" + "; function2callback-apu2context4xi-yielded-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z1-'


    if 'COUNT2REFERENCE' in keys2task:        
        message2print = "{(Step 8A/70) try" + "; count2reference-try-by-create2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 8/70) - COUNT2REFERENCE
            # -----------------------------------------------------------------------------------------               
            apu2context4xi['COUNT2REFERENCE'] = task4create2apu['COUNT2REFERENCE']
            
            message2print = "{(Step 8B/70) initialized" + "; count2reference-initialized-by-create2context4apu to: " + str(apu2context4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '7B-'
        except: 
            message2print = "{(Step 8Z1/70) yielded" + "; count2reference-apu2context4xi-yielded-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z1-'        
                                                 
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2context4xi ['ACK2RETURN']  = code2ack
    apu2context4xi ['NACK2RETURN'] = code2nack
    
    message2print = "{(Step 70/70) returning" + "; apu2context4xi-returning-by-create2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 20:55:51 05/11/11 Pacific Daylight Time}', 
    #          'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 
    #  'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000032098C8>, 
    #         'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B', 
    #       'INFO2PRIVATE': None, 
    #           'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #        'NACK2RETURN': ' ', 
    #       'SIZE2PRIVATE': 0, 
    #         'PROPERTIES': None
    # }; time: 20:55:51 05/11/11 Pacific Daylight Time}
 

    
    return apu2context4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2context4apu" usage = "
#
# Example (from context4xi.py - task4set2context got as parameter - see context4xi5test.py)
#
#     if context4xi is None:
#         context4xi = create2context4xi()                                                                               # CREATE CONTEXT4XI
# try:
#     -----------------------------------------------------------------------------
#     (Step 4A/33)
#     ----------------------------------------------------------------------------- 
#     message2print = "{(Step 4A/33) passing" + "; task-passing-to-set2context4apu: " + str(task4set2context['APU'])  + "; time: " + time4xi() + "}"  
#     print4xi(class2print, method2print, message2print)                                                         
#        
#     context4xi ['APU'] = set2context4apu(task4set2context['APU'])                                                      # 
#          
#     message2print = "{(Step 4B/33) set" + "; apu-context-set-by-set2context4apu to: " + str(context4xi ['APU'])  + "; time: " + time4xi() + "}"
#     print4xi(class2print, method2print, message2print)                                                          
#     code2ack  = code2ack + '4B-'
# except:
#     message2print = "{(Step 4Z1/33) yielded" + "; apu-yielded-by-set2context4xi: " + 'APU' + "; time: " + time4xi() + "}"
#     print4xi(class2print, method2print, message2print) 
#     code2nack  = code2nack + '4Z1-'
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def set2context4apu(task4set2apu=None):

    '''
    sets apu2context4xi
    '''
    global apu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2context4apu"
    method2print = "set2context4apu"

    message2print = "{(Step 1A/33) started" + "; set2context4apu-started: " + str(set2context4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2context4apu at 0x000000000331CD48>
    
    message2print = "{(Step 1B/33) passed" + "; task4set2apu-to-set2context4apu: " + str(task4set2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 
    #  'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 
    #  'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000331CC48>, 'INFO2PRIVATE': None, 
    #           'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #       'SIZE2PRIVATE': 0, 
    #         'PROPERTIES': None
    #}; time: 23:20:05 05/11/11 Pacific Daylight Time}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if apu2context4xi is None:
            apu2context4xi = create2context4apu()                                                                              # INITIALIZE CONTEXT FOR APU                      
    except:
        try:
            apu2context4xi = create2context4apu()
        except:
            apu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 2A/70) try" + "; platform-try-by-set2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 2/70) - PLATFORM (DIRECT TRANSFER FROM INPUT TRIED - AS WITH OTHERS)
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['PLATFORM'] = task4set2apu['PLATFORM']
        
        message2print = "{(Step 2B/70) set" + "; platform-set-by-set2context4apu to: " + str(apu2context4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 23:20:05 05/11/11 Pacific Daylight Time}

        code2ack  = code2ack + '2B-'
    except: 
        message2print = "{(Step 2Z1/70) yielded" + "; platform-apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '2Z1-' 
        
    message2print = "{(Step 3A/70) try" + "; properties-try-by-set2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 3/70) - PROPERTIES
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['PROPERTIES'] = task4set2apu['PROPERTIES']
        
        message2print = "{(Step 3B/70) set" + "; properties-set-by-set2context4apu to: " + str(apu2context4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # None
        code2ack  = code2ack + '3B-'
    except: 
        message2print = "{(Step 3Z1/70) yielded" + "; properties-apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '3Z1-' 
        
    message2print = "{(Step 4A/70) try" + "; data2callback-try-by-set2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 4/70) - DATA2CALLBACK
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['DATA2CALLBACK'] = task4set2apu['DATA2CALLBACK']
        
        message2print = "{(Step 4B/70) set" + "; data2callback-set-by-set2context4apu to: " + str(apu2context4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 
        #    'CLASS': 'get2context4apu', 
        #   'METHOD': 'get2context4xi4apu'}; time: 23:20:05 05/11/11 Pacific Daylight Time}

        code2ack  = code2ack + '4B-'
    except: 
        message2print = "{(Step 4Z1/70) yielded" + "; data2callback-apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '4Z1-'
         
    message2print = "{(Step 5A/70) try" + "; info2private-try-by-set2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 5/70) - INFO2PRIVATE
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['INFO2PRIVATE'] = task4set2apu['INFO2PRIVATE']
        
        message2print = "{(Step 5B/70) set" + "; info2private-set-by-set2context4apu to: " + str(apu2context4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # None
        code2ack  = code2ack + '5B-'
    except: 
        message2print = "{(Step 5Z1/70) yielded" + "; info2private-apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '5Z1-'         
    
    message2print = "{(Step 6A/70) try" + "; size2private-try-by-set2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 6/70) - SIZE2PRIVATE
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['SIZE2PRIVATE'] = task4set2apu['SIZE2PRIVATE']
        
        message2print = "{(Step 6B/70) set" + "; size2private-set-by-set2context4apu to: " + str(apu2context4xi['SIZE2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
        code2ack  = code2ack + '6B-'
    except: 
        message2print = "{(Step 6Z1/70) yielded" + "; size2private-apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '6Z1-'
        
    message2print = "{(Step 7A/70) try" + "; function2callback-try-by-set2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000331CC48>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 23:20:05 05/11/11 Pacific Daylight Time}

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 7/70) - FUNCTION2CALLBACK
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['FUNCTION2CALLBACK'] = task4set2apu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 7B/70) set" + "; function2callback-set-by-set2context4apu to: " + str(apu2context4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <function trace2context4apu at 0x000000000331CC48>
        code2ack  = code2ack + '7B-'
    except: 
        message2print = "{(Step 7Z1/70) yielded" + "; function2callback-apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '7Z1-'


    try:
        # -----------------------------------------------------------------------------------------
        # (Step 8/70) - COUNT2REFERENCE
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['COUNT2REFERENCE'] = task4set2apu['COUNT2REFERENCE']
        
        message2print = "{(Step 8B/70) set" + "; count2reference-set-by-set2context4apu to: " + str(apu2context4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '8B-'
    except: 
        message2print = "{(Step 8Z1/70) yielded" + "; count2reference-apu2context4xi-yielded-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '8Z1-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2context4xi ['ACK2RETURN']  = code2ack
    apu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; apu2context4xi-returning-by-set2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # apu2context4xi-returning-by-set2context4apu: 
    #  {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 
    #                       'CLASS': 'get2context4apu', 
    #                      'METHOD': 'get2context4xi4apu'}, 
    #   'FUNCTION2CALLBACK': <function trace2context4apu at 0x000000000331CC48>, 
    #          'ACK2RETURN': ' 2B3B4B5B6B7B', 
    #        'INFO2PRIVATE': None, 
    #            'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #         'NACK2RETURN': ' ', 
    #        'SIZE2PRIVATE': 0, 
    #          'PROPERTIES': None
    # }; time: 23:20:05 05/11/11 Pacific Daylight Time}

    return apu2context4xi

            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2context4apu" usage = "
#
# Example (see context4xi5test.py)
# (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECRENTING COUNT WITH 1             
#   task4release2context = {}
#   task4release2context ['APU'] = {} 
#    
#   task4release2context ['APU'] ['COUNT2REFERENCE'] = 1                                                            # REFERENCE COUNT
#   response4release2context = {}
#   
#   print('(Step 5A/33) OF CONTEXT4XI5TEST - TRYING TO RELEASE CONTEXT OF APU DEVICE ', time4xi())  
#   try:                               
#       response4release2context = release2context4xi(task4release2context)                                         # COUNT2REFERENCE                                                      
#       print('(Step 5BD/33) OF CONTEXT4XI5TEST - RESPONSE4RELEASE2CONTEXT : ', response4release2context)                          
#       
#   except:
#       print('(Step 5Z1/33) OF CONTEXT4XI5TEST *** FAILED TO RELEASE CONTEXT OF APU DEVICE ', time4xi())  
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def release2context4apu(task4release2apu=None):

    '''
    releases apu2context4xi
    '''
    global apu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2context4apu"
    method2print = "release2context4apu" 

    message2print = "{(Step 1A/33) started" + "; release2context4apu-started: " + str(release2context4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2context4apu at 0x0000000003361348> 
    
    message2print = "{(Step 1B/33) passed" + "; task4release2apu-to-release2context4apu: " + str(task4release2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if apu2context4xi is None:
            apu2context4xi = create2context4apu()                                                                              # INITIALIZE CONTEXT                 
    except:
        try:
            apu2context4xi = create2context4apu()
        except:
            apu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; apu2context4xi-yielded-by-release2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2apu is None:
        task4release2apu = {}
        task4release2apu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['COUNT2REFERENCE'] = apu2context4xi['COUNT2REFERENCE'] - task4release2apu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2context4apu: " + str(apu2context4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if apu2context4xi['COUNT2REFERENCE'] < 0:
            apu2context4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2context4apu: " + " ** " + str(apu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            apu2context4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2context4apu: " + " ** " + str(apu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; apu2context4xi-yielded-by-release2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2context4xi ['ACK2RETURN']  = code2ack
    apu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; apu2context4xi-returning-by-release2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 
    
    return apu2context4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2context4apu" usage = "
#
# Example (see context4xi5test.py)
# (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAIND BY INCREMENTING COUNT WITH 1             
#   task4retain2context = {}
#   task4retain2context ['APU'] = {} 
#    
#   task4retain2context ['APU'] ['COUNT2REFERENCE'] = 1                  # ADD REFERENCE COUNT BY 1
#   response4retain2context = {}
#   
#   print('(Step 5A/33) OF CONTEXT4XI5TEST - TRYING TO RETAIN CONTEXT OF APU DEVICE ', time4xi())  
#   try:                               
#       response4retain2context = retain2context4xi(task4retain2context)                                                                                          
#       print('(Step 5BD/33) OF CONTEXT4XI5TEST - RESPONSE4RETAIN2CONTEXT : ', response4retain2context)                          
#       
#   except:
#       print('(Step 5Z1/33) OF CONTEXT4XI5TEST *** FAILED TO RETAIN CONTEXT OF APU DEVICE ', time4xi())  
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def retain2context4apu(task4retain2apu=None):

    '''
    retains apu2context4xi
    '''
    global apu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2context4apu"
    method2print = "retain2context4apu"

    message2print = "{(Step 1A/33) started" + "; retain2context4apu-started: " + str(retain2context4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2apu-to-retain2context4apu: " + str(task4retain2apu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if apu2context4xi is None:
            apu2context4xi = create2context4apu()                                                                              # INITIALIZE CONTEXT                 
    except:
        try:
            apu2context4xi = create2context4apu()
        except:
            apu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; apu2context4xi-yielded-by-retain2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; retain-try-by-retain2context4apu: " + str(apu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
           
    try:
        # -----------------------------------------------------------------------------------------
        # RETAIN
        # -----------------------------------------------------------------------------------------               
        apu2context4xi['COUNT2REFERENCE'] = apu2context4xi['COUNT2REFERENCE'] + task4retain2apu['COUNT2REFERENCE']
        
        message2print = "{(Step 1C/70) calculated" + "; count2reference-calculated-by-retain2context4apu: " + str(apu2context4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #
         
        if apu2context4xi['COUNT2REFERENCE'] <= 0:
            apu2context4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1D/70) warning" + "; count2reference-warning-by-retain2context4apu: " + " ** " + str(apu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1D-'
        else:
            code2ack  = code2ack + '1D-'
    except:
        try:
            apu2context4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1Z1/70) warning" + "; count2reference-warning-by-retain2context4apu: " + " ** " + str(apu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '1Z1-'
            
        except:
            message2print = "{(Step 1Z2/70) yielded" + "; apu2context4xi-yielded-by-retain2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    apu2context4xi ['ACK2RETURN']  = code2ack
    apu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; apu2context4xi-returning-by-retain2context4apu: " + str(apu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    #  {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}

    
    return apu2context4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2context4apu" usage = "
#
#    try:                               
#        response4get2apu = get2context4apu()                                        
#                                                                                                                   
#    except:
#        ... 
#                          
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def get2context4apu():

    '''
    gets apu2context4xi
    '''
    
    global apu2context4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2context4apu"
    method2print = "get2context4apu"

    message2print = "{(Step 1A/33) started" + "; get2context4apu-started: " + str(get2context4apu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function get2context4apu at 0x000000000323E048>                                                              
    try: 
        if apu2context4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            apu2xi = create2context4apu()
            message2print = "{(Step 1B/33) initialized" + "; apu2xi-initialized-by-get2context4apu to: " + str(apu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
        else:
            # -------------------------------------------------------------------------------------
            # RETURN THE EXISTING CONTEXT FOR APU          
            # -------------------------------------------------------------------------------------     
            apu2xi = apu2context4xi
            message2print = "{(Step 1C/33) got" + "; apu2xi-got-by-get2context4apu: " + str(apu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            apu2xi = create2context4apu()
            
            message2print = "{(Step 1D/33) initialized" + "; apu2xi-initialized-by-get2context4apu to: " + str(apu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 08:44:09 05/19/11 Pacific Daylight Time}', 
            #             'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 
            # 'FUNCTION2CALLBACK': <function trace2context4apu at 0x0000000003230D48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 
            #      'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 08:44:09 05/19/11 Pacific Daylight Time}
               
            
        except:
            apu2xi = {}            
            message2print = "{(Step 1Z2/70) yielded" + "; apu2xi-yielded-by-retain2context4apu: " + str(apu2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                    
    message2print = "{(Step 33/33) returning" + "; apu2xi-returning-by-get2context4apu: " + str(apu2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 04:14:11 05/21/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000037AE448>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:14:11 05/21/11 Pacific Daylight Time}
  
    
    return apu2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
# APU2Context4Xi class
#<class4xi class = "APU2Context4Xi" base = "object" child = "None"
#       synopsis = "offers  methods for APU" usage = "OpenCL APU"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class APU2Context4Xi(object): 
    ''' 
    APU2Context4Xi offers  methods for APU context
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2apu = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2apu',
    'get2apu',
    'release2apu',
    'retain2apu',
    'set2apu',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-APU2Context4Xi" usage = "
    #example:
    # try:
    #     # ---------------------------------------------------------------------------------------------
    #     # CREATE OBJECT                        
    #     # ---------------------------------------------------------------------------------------------        
    #     cc2xi = APU2Context4Xi()
    #     print('(Step 5B/33) OF APU4XI5TEST - CREATED APU2Context4Xi OBJECT: ', cc2xi)                                       
    # except:
    #     print('(Step 5Z/33) OF APU4XI5TEST *** FAILED TO CREATE APU2Context4Xi OBJECT')
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2apu = None):
        '''
        _init__ method initializes APU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "APU2Context4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 

        message2print = "{(Step 1B/33) borning" + "; apu2context2xi-of-APU2Context4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-apu2context2xi-of-APU2Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2apu-sharing-by-apu2context2xi-of-APU2Context4Xi: " + str(APU2Context4Xi.classvariable2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2apu-passed-to-init-of-APU2Context4Xi: " + str(task4create2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                               
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2apu-passing-to-create2context4apu-by-init-of-APU2Context4Xi: " + str(task4create2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
        
        apu2context2xi = create2context4apu(task4create2apu)
        
        message2print = "{(Step 2B/33) performed" + "; create2context4apu-performed-by-init-of-APU2Context4Xi: " + str(create2context4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; apu2context2xi-of-APU2Context4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-apu2context2xi-of-APU2Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2apu-shared-by-apu2context2xi-of-APU2Context4Xi: " + str(APU2Context4Xi.classvariable2apu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #               
       
        message2print = "{(Step 3D/33) returning" + "; init-of-APU2Context4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-APU2Context4Xi" usage = "
    # print('(Step 1A/33) OF APU2CONTEXT4XI - TRYING TO CREATE APU CONTEXT')
    # try:
    #     cc2xi = APU2Context4Xi()                            
    #     context2apu = cc2xi.create2apu()                                  
    #     print('(Step 1B/33) OF APU4XI5TEST - SET APU CONTEXT: ', context2apu)                                                  
    # except:
    #     print('(Step 1Z/33) OF APU4XI5TEST *** FAILED TO SET APU CONTEXT ***')
    #">   
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def create2apu(self, task4create2apu = None):
        '''
        create2apu method creates objects of APU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Context4Xi"
        method2print = "create2apu"
                     
        message2print = "{(Step 1A/33) started" + "; create2apu-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4create2apu-passed-to-create2apu-of-APU2Context4Xi: " + str(task4create2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2apu-passing-to-create2context4apu-by-create2apu-of-APU2Context4Xi: " + str(task4create2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        apu2context2xi = create2context4apu(task4create2apu)

        message2print = "{(Step 2B/33) performed" + "; create2context4apu-performed-by-create2apu-of-APU2Context4Xi: " + str(create2context4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; apu2context2xi-returning-by-create2apu-of-APU2Context4Xi: " + str(apu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
 
                
        return apu2context2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2apu-of-APU2Context4Xi" usage = "
    # print('(Step 1A/33) OF APU2CONTEXT4XI - TRYING TO SET APU CONTEXT')
    # try:
    #     cc2xi = APU2Context4Xi()                            
    #     context2apu = cc2xi.set2apu()                                  
    #     print('(Step 1B/33) OF APU4XI5TEST - SET APU CONTEXT: ', context2apu)                                                  
    # except:
    #     print('(Step 1Z/33) OF APU4XI5TEST *** FAILED TO SET APU CONTEXT ***')  
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def set2apu(self, task4set2apu = None):
        '''
        sets APU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Context4Xi"
        method2print = "set2apu"
                     
        message2print = "{(Step 1A/33) started" + "; set2apu-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4set2apu-passed-to-set2apu-of-APU2Context4Xi: " + str(task4set2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2apu-passing-to-set2context4apu-by-set2apu-of-APU2Context4Xi: " + str(task4set2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        apu2context2xi = set2context4apu(task4set2apu)

        message2print = "{(Step 2B/33) performed" + "; set2context4apu-performed-by-set2apu-of-APU2Context4Xi: " + str(set2context4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; apu2context2xi-returning-by-set2apu-of-APU2Context4Xi: " + str(apu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return apu2context2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2apu-of-APU2Context4Xi" usage = "
    # print('(Step 1A/33) OF APU2CONTEXT4XI - TRYING TO GET APU CONTEXT')
    # try:
    #     cc2xi = APU2Context4Xi()                            
    #     context2apu = cc2xi.get2apu()                                  
    #     print('(Step 1B/33) OF APU4XI5TEST - GOT APU CONTEXT: ', context2apu)                                                  
    # except:
    #     print('(Step 1Z/33) OF APU4XI5TEST *** FAILED TO GET APU CONTEXT ***')   
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def get2apu(self):
        '''
        get2apu method gets objects of APU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Context4Xi"
        method2print = "get2apu"
                     
        message2print = "{(Step 1A/33) started" + "; get2apu-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        apu2context2xi = get2context4apu()
        
        message2print = "{(Step 2A/33) returning" + "; apu2context2xi-returning-by-get2apu-of-APU2Context4Xi: " + str(apu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return apu2context2xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2apu-of-APU2Context4Xi" usage = "
    # print('(Step 1A/33) OF APU2CONTEXT4XI - TRYING TO SET APU CONTEXT')
    # try:
    #     cc2xi = APU2Context4Xi()                            
    #     context2apu = cc2xi.release2apu()                                  
    #     print('(Step 1B/33) OF APU4XI5TEST - SET APU CONTEXT: ', context2apu)                                                  
    # except:
    #     print('(Step 1Z/33) OF APU4XI5TEST *** FAILED TO SET APU CONTEXT ***')  
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def release2apu(self, task4release2apu = None):
        '''
        releases APU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Context4Xi"
        method2print = "release2apu"
                     
        message2print = "{(Step 1A/33) started" + "; release2apu-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4release2apu-passed-to-release2apu-of-APU2Context4Xi: " + str(task4release2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2apu-passing-to-release2context4apu-by-release2apu-of-APU2Context4Xi: " + str(task4release2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        apu2context2xi = release2context4apu(task4release2apu)

        message2print = "{(Step 2B/33) performed" + "; release2context4apu-performed-by-release2apu-of-APU2Context4Xi: " + str(release2context4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; apu2context2xi-returning-by-release2apu-of-APU2Context4Xi: " + str(apu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return apu2context2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2apu-of-APU2Context4Xi" usage = "
    # print('(Step 1A/33) OF APU2CONTEXT4XI - TRYING TO SET APU CONTEXT')
    # try:
    #     cc2xi = APU2Context4Xi()                            
    #     context2apu = cc2xi.retain2apu()                                  
    #     print('(Step 1B/33) OF APU4XI5TEST - SET APU CONTEXT: ', context2apu)                                                  
    # except:
    #     print('(Step 1Z/33) OF APU4XI5TEST *** FAILED TO SET APU CONTEXT ***')  
    #">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def retain2apu(self, task4retain2apu = None):
        '''
        retains APU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "APU2Context4Xi"
        method2print = "retain2apu"
                     
        message2print = "{(Step 1A/33) started" + "; retain2apu-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2apu-passed-to-retain2apu-of-APU2Context4Xi: " + str(task4retain2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2apu-passing-to-retain2context4apu-by-retain2apu-of-APU2Context4Xi: " + str(task4retain2apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        apu2context2xi = retain2context4apu(task4retain2apu)

        message2print = "{(Step 2B/33) performed" + "; retain2context4apu-performed-by-retain2apu-of-APU2Context4Xi: " + str(retain2context4apu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; apu2context2xi-returning-by-retain2apu-of-APU2Context4Xi: " + str(apu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return apu2context2xi
                                                           
    #</methodize4xi>   
                                         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-APU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.sense())
    # 
    #     print('=' *33)          
    #     print('(Step 15B/33) OF APU4XI5TEST - SENSED ', time4xi())                                                  
    #                                                                                                                 
    #     print('=' *33)
    # except:
    #     print('(Step 15Z/33) OF APU4XI5TEST *** FAILED TO SENSE ', time4xi())    
    # 
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses APU2Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'APU2Context4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; APU2Context4Xi-sensing-by-sense-of-APU2Context4Xi: " + str(APU2Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-APU2Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2apu-of-APU2Context4Xi'] = APU2Context4Xi.classvariable2apu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-APU2Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; APU2Context4Xi-sensed-by-sense-of-APU2Context4Xi: " + str(APU2Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-APU2Context4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                    
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-APU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.reason())
    # 
    #     print('=' *33)          
    #     print('(Step 17B/33) OF APU4XI5TEST - REASONED ', time4xi())                                                
    #     print('=' *33)       
    # except:
    #     print('(Step 17Z/33) OF APU4XI5TEST *** FAILED TO REASON ', time4xi())     
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons APU2Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'APU2Context4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; APU2Context4Xi-reasoning-by-reason-of-APU2Context4Xi: " + str(APU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-APU2Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-APU2Context4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-APU2Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; APU2Context4Xi-reasoned-by-reason-of-APU2Context4Xi: " + str(APU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-APU2Context4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                     
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-APU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.ace())
    # 
    #     print('=' *33)          
    #     print('(Step 21B/33) OF APU4XI5TEST - ACED ', time4xi())                                                    
    #     print('=' *33) 
    # except:
    #     print('(Step 21Z/33) OF APU4XI5TEST *** FAILED TO ACE ', time4xi())      
    # 
    # ">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces APU2Context4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'APU2Context4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-APU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; APU2Context4Xi-acing-by-ace-of-APU2Context4Xi: " + str(APU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-APU2Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-APU2Context4Xi'] = APU2Context4Xi.classvariable2apu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-APU2Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; APU2Context4Xi-aced-by-ace-of-APU2Context4Xi: " + str(APU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-APU2Context4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   context4xi.txt
#   sense-context4xi.xml
#   reason-context4xi.xml
#   ace-context4xi.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of apu2context4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
